#include <MacroPatternMatch.h>
#include "HROOTCoreTDictionary.h"
#include "TGlobal.h"
#include "HROOTCoreTGlobal.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TDICTIONARY_DEF_VIRT(TGlobal)
TNAMED_DEF_VIRT(TGlobal)
TOBJECT_DEF_VIRT(TGlobal)
DELETABLE_DEF_VIRT(TGlobal)

TGLOBAL_DEF_VIRT(TGlobal)

TGLOBAL_DEF_NONVIRT(TGlobal)

