#include <MacroPatternMatch.h>
#include "HROOTCoreTClass.h"
#include "HROOTCoreTDirectory.h"
#include "HROOTCoreTNamed.h"
#include "TKey.h"
#include "HROOTCoreTKey.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TKey)
TOBJECT_DEF_VIRT(TKey)
DELETABLE_DEF_VIRT(TKey)

TKEY_DEF_VIRT(TKey)

TKEY_DEF_NONVIRT(TKey)

