#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_CORE__TKey__
#define __HROOT_CORE__TKey__

#include "HROOT-coreType.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TKEY_DECL_VIRT 
#define TKEY_DECL_VIRT(Type) \


#undef TKEY_DECL_NONVIRT 
#define TKEY_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTKey ( const char* name, const char* title, TClass_p cl, int nbytes, TDirectory_p motherDir )

#undef TKEY_DEF_VIRT
#define TKEY_DEF_VIRT(Type)\


#undef TKEY_DEF_NONVIRT
#define TKEY_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTKey ( const char* name, const char* title, TClass_p cl, int nbytes, TDirectory_p motherDir )\
{\
Type * newp = new Type (name, title, to_nonconst<TClass,TClass_t>(cl), nbytes, to_nonconst<TDirectory,TDirectory_t>(motherDir)); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TNAMED_DECL_VIRT(TKey);
TOBJECT_DECL_VIRT(TKey);
DELETABLE_DECL_VIRT(TKey);


TKEY_DECL_VIRT(TKey);


TKEY_DECL_NONVIRT(TKey);


#endif // __HROOT_CORE__TKey__

#ifdef __cplusplus
}
#endif

