#include <MacroPatternMatch.h>
#include "HROOTCoreTNamed.h"
#include "TSystem.h"
#include "HROOTCoreTSystem.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TSystem)
TOBJECT_DEF_VIRT(TSystem)
DELETABLE_DEF_VIRT(TSystem)

TSYSTEM_DEF_VIRT(TSystem)

TSYSTEM_DEF_NONVIRT(TSystem)

