{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttCanvas.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TAttCanvas.RawType
import HROOT.Core.TAttCanvas.FFI
import HROOT.Core.TAttCanvas.Interface
import HROOT.Core.TAttCanvas.Cast
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITAttCanvas TAttCanvas

instance IDeletable TAttCanvas where
        delete = xform0 c_tattcanvas_delete

newTAttCanvas :: IO TAttCanvas
newTAttCanvas = xformnull c_tattcanvas_newtattcanvas
