{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TObjArray.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.FFI
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TSeqCollection.RawType
import HROOT.Core.TSeqCollection.Cast
import HROOT.Core.TSeqCollection.Interface
import HROOT.Core.TCollection.RawType
import HROOT.Core.TCollection.Cast
import HROOT.Core.TCollection.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITObjArray TObjArray

instance ITSeqCollection TObjArray

instance ITCollection TObjArray

instance ITObject TObjArray where
        draw = xform1 c_tobjarray_draw
        findObject = xform1 c_tobjarray_findobject
        getName = xform0 c_tobjarray_getname
        isA = xform0 c_tobjarray_isa
        paint = xform1 c_tobjarray_paint
        printObj = xform1 c_tobjarray_printobj
        saveAs = xform2 c_tobjarray_saveas
        write = xform3 c_tobjarray_write

instance IDeletable TObjArray where
        delete = xform0 c_tobjarray_delete
