{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttCanvas.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttCanvas.RawType
import HROOT.Core.Deletable.Interface

class IDeletable a => ITAttCanvas a

upcastTAttCanvas ::
                 forall a . (FPtr a, ITAttCanvas a) => a -> TAttCanvas
upcastTAttCanvas h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttCanvas = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttCanvas ::
                   forall a . (FPtr a, ITAttCanvas a) => TAttCanvas -> a
downcastTAttCanvas h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
