{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TCollection.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TCollection.RawType
import HROOT.Core.TCollection.FFI
import HROOT.Core.TCollection.Interface
import HROOT.Core.TCollection.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITCollection TCollection

instance ITObject TCollection where
        draw = xform1 c_tcollection_draw
        findObject = xform1 c_tcollection_findobject
        getName = xform0 c_tcollection_getname
        isA = xform0 c_tcollection_isa
        paint = xform1 c_tcollection_paint
        printObj = xform1 c_tcollection_printobj
        saveAs = xform2 c_tcollection_saveas
        write = xform3 c_tcollection_write

instance IDeletable TCollection where
        delete = xform0 c_tcollection_delete
