{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TGlobal.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TGlobal.RawType
import HROOT.Core.TGlobal.FFI
import HROOT.Core.TGlobal.Interface
import HROOT.Core.TGlobal.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TDictionary.RawType
import HROOT.Core.TDictionary.Cast
import HROOT.Core.TDictionary.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITGlobal TGlobal

instance ITDictionary TGlobal

instance ITNamed TGlobal where
        setName = xform1 c_tglobal_setname
        setNameTitle = xform2 c_tglobal_setnametitle
        setTitle = xform1 c_tglobal_settitle

instance ITObject TGlobal where
        draw = xform1 c_tglobal_draw
        findObject = xform1 c_tglobal_findobject
        getName = xform0 c_tglobal_getname
        isA = xform0 c_tglobal_isa
        paint = xform1 c_tglobal_paint
        printObj = xform1 c_tglobal_printobj
        saveAs = xform2 c_tglobal_saveas
        write = xform3 c_tglobal_write

instance IDeletable TGlobal where
        delete = xform0 c_tglobal_delete
